/*-
 * SPDX-License-Identifier: BSD-3-Clause
 *
 * Copyright (c) 2018 Rafal Kozik
 * All rights reserved.
 */

MEMORY
{
	FLASH (rx) : ORIGIN = 0x08000000, LENGTH = 64K
	RAM (rwx) : ORIGIN = 0x20000000, LENGTH = 8K
}

SECTIONS
{
	.text :
	{
		KEEP(*(.vector_table))
		*(.text)
		*(.text.*)
		*(.rodata)
		*(.rodata.*)
		. = ALIGN(4);
	} >FLASH =0xff

	.ARM.exidx :
	{
		. = ALIGN(4);
    	*(.ARM.exidx*)
    	*(.gnu.linkonce.armexidx.*)
		. = ALIGN(4);
		_etext = .;
		_sidata = _etext;
	} >FLASH =0xff
	
	.data : AT(_sidata)
	{
		. = ALIGN(4);
		_sdata = .;
		*(.data)
		*(.data.*)
		. = ALIGN(4);
		_edata = .;
	} >RAM =0
	
	.bss :
	{
		. = ALIGN(4);
		_sbss = .;
		*(.bss)
		*(.bss.*)
		*(COMMON)
		. = ALIGN(4);
		_ebss = .;
	} >RAM

	_estack = (ORIGIN(RAM) + LENGTH(RAM));	   
	PROVIDE(_end = _ebss);
}
